/// <reference types="node" />
import * as https from 'https';
declare type HttpsAgent = https.Agent;
import * as http from 'http';
declare type HttpAgent = http.Agent;
import * as tunnel from 'tunnel';
import { Spread } from './types/utils';
export declare type IAgentOptions = tunnel.HttpOptions | tunnel.HttpOverHttpsOptions | tunnel.HttpsOverHttpOptions | tunnel.HttpsOverHttpsOptions;
export declare type IProxyOptions = tunnel.ProxyOptions & {
    protocol: 'http:' | 'https:';
};
export declare type IProxyHttpsOptions = tunnel.HttpsProxyOptions & {
    protocol: 'http:' | 'https:';
};
export declare type IOptions = Spread<Partial<https.AgentOptions> & IAgentOptions, {
    proxy: IProxyOptions | IProxyHttpsOptions | string;
    endServerProtocol?: 'http:' | 'https:';
}>;
export declare function getProxyHttpAgent(options: IOptions): http.Agent | https.Agent;
export { HttpsAgent, HttpAgent };
